Code

Merge branch 'tr/merge-edit-guidance'
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22         # do not redirect again
23         ;;
24 *' --tee '*|*' --va'*)
25         mkdir -p test-results
26         BASE=test-results/$(basename "$0" .sh)
27         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28          echo $? > $BASE.exit) | tee $BASE.out
29         test "$(cat $BASE.exit)" = 0
30         exit
31         ;;
32 esac
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 EDITOR=:
45 unset VISUAL
46 unset EMAIL
47 unset LANGUAGE
48 unset $(perl -e '
49         my @env = keys %ENV;
50         my $ok = join("|", qw(
51                 TRACE
52                 DEBUG
53                 USE_LOOKUP
54                 TEST
55                 .*_TEST
56                 PROVE
57                 VALGRIND
58         ));
59         my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
60         print join("\n", @vars);
61 ')
62 GIT_AUTHOR_EMAIL=author@example.com
63 GIT_AUTHOR_NAME='A U Thor'
64 GIT_COMMITTER_EMAIL=committer@example.com
65 GIT_COMMITTER_NAME='C O Mitter'
66 GIT_MERGE_VERBOSITY=5
67 GIT_MERGE_AUTOEDIT=no
68 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
69 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
70 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
71 export EDITOR
73 # Protect ourselves from common misconfiguration to export
74 # CDPATH into the environment
75 unset CDPATH
77 unset GREP_OPTIONS
79 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
80         1|2|true)
81                 echo "* warning: Some tests will not work if GIT_TRACE" \
82                         "is set as to trace on STDERR ! *"
83                 echo "* warning: Please set GIT_TRACE to something" \
84                         "other than 1, 2 or true ! *"
85                 ;;
86 esac
88 # Convenience
89 #
90 # A regexp to match 5 and 40 hexdigits
91 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
92 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
94 # Zero SHA-1
95 _z40=0000000000000000000000000000000000000000
97 # Line feed
98 LF='
99 '
101 # Each test should start with something like this, after copyright notices:
103 # test_description='Description of this test...
104 # This test checks if command xyzzy does the right thing...
105 # '
106 # . ./test-lib.sh
107 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
108                 TERM=$ORIGINAL_TERM &&
109                 export TERM &&
110                 [ -t 1 ] &&
111                 tput bold >/dev/null 2>&1 &&
112                 tput setaf 1 >/dev/null 2>&1 &&
113                 tput sgr0 >/dev/null 2>&1
114         ) &&
115         color=t
117 while test "$#" -ne 0
118 do
119         case "$1" in
120         -d|--d|--de|--deb|--debu|--debug)
121                 debug=t; shift ;;
122         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
123                 immediate=t; shift ;;
124         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
125                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
126         -h|--h|--he|--hel|--help)
127                 help=t; shift ;;
128         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
129                 verbose=t; shift ;;
130         -q|--q|--qu|--qui|--quie|--quiet)
131                 # Ignore --quiet under a TAP::Harness. Saying how many tests
132                 # passed without the ok/not ok details is always an error.
133                 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
134         --with-dashes)
135                 with_dashes=t; shift ;;
136         --no-color)
137                 color=; shift ;;
138         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
139                 valgrind=t; verbose=t; shift ;;
140         --tee)
141                 shift ;; # was handled already
142         --root=*)
143                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
144                 shift ;;
145         *)
146                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
147         esac
148 done
150 if test -n "$color"; then
151         say_color () {
152                 (
153                 TERM=$ORIGINAL_TERM
154                 export TERM
155                 case "$1" in
156                         error) tput bold; tput setaf 1;; # bold red
157                         skip)  tput bold; tput setaf 2;; # bold green
158                         pass)  tput setaf 2;;            # green
159                         info)  tput setaf 3;;            # brown
160                         *) test -n "$quiet" && return;;
161                 esac
162                 shift
163                 printf "%s" "$*"
164                 tput sgr0
165                 echo
166                 )
167         }
168 else
169         say_color() {
170                 test -z "$1" && test -n "$quiet" && return
171                 shift
172                 echo "$*"
173         }
174 fi
176 error () {
177         say_color error "error: $*"
178         GIT_EXIT_OK=t
179         exit 1
182 say () {
183         say_color info "$*"
186 test "${test_description}" != "" ||
187 error "Test script did not set test_description."
189 if test "$help" = "t"
190 then
191         echo "$test_description"
192         exit 0
193 fi
195 exec 5>&1
196 exec 6<&0
197 if test "$verbose" = "t"
198 then
199         exec 4>&2 3>&1
200 else
201         exec 4>/dev/null 3>/dev/null
202 fi
204 test_failure=0
205 test_count=0
206 test_fixed=0
207 test_broken=0
208 test_success=0
210 test_external_has_tap=0
212 die () {
213         code=$?
214         if test -n "$GIT_EXIT_OK"
215         then
216                 exit $code
217         else
218                 echo >&5 "FATAL: Unexpected exit with code $code"
219                 exit 1
220         fi
223 GIT_EXIT_OK=
224 trap 'die' EXIT
226 # The semantics of the editor variables are that of invoking
227 # sh -c "$EDITOR \"$@\"" files ...
229 # If our trash directory contains shell metacharacters, they will be
230 # interpreted if we just set $EDITOR directly, so do a little dance with
231 # environment variables to work around this.
233 # In particular, quoting isn't enough, as the path may contain the same quote
234 # that we're using.
235 test_set_editor () {
236         FAKE_EDITOR="$1"
237         export FAKE_EDITOR
238         EDITOR='"$FAKE_EDITOR"'
239         export EDITOR
242 test_decode_color () {
243         awk '
244                 function name(n) {
245                         if (n == 0) return "RESET";
246                         if (n == 1) return "BOLD";
247                         if (n == 30) return "BLACK";
248                         if (n == 31) return "RED";
249                         if (n == 32) return "GREEN";
250                         if (n == 33) return "YELLOW";
251                         if (n == 34) return "BLUE";
252                         if (n == 35) return "MAGENTA";
253                         if (n == 36) return "CYAN";
254                         if (n == 37) return "WHITE";
255                         if (n == 40) return "BLACK";
256                         if (n == 41) return "BRED";
257                         if (n == 42) return "BGREEN";
258                         if (n == 43) return "BYELLOW";
259                         if (n == 44) return "BBLUE";
260                         if (n == 45) return "BMAGENTA";
261                         if (n == 46) return "BCYAN";
262                         if (n == 47) return "BWHITE";
263                 }
264                 {
265                         while (match($0, /\033\[[0-9;]*m/) != 0) {
266                                 printf "%s<", substr($0, 1, RSTART-1);
267                                 codes = substr($0, RSTART+2, RLENGTH-3);
268                                 if (length(codes) == 0)
269                                         printf "%s", name(0)
270                                 else {
271                                         n = split(codes, ary, ";");
272                                         sep = "";
273                                         for (i = 1; i <= n; i++) {
274                                                 printf "%s%s", sep, name(ary[i]);
275                                                 sep = ";"
276                                         }
277                                 }
278                                 printf ">";
279                                 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
280                         }
281                         print
282                 }
283         '
286 nul_to_q () {
287         perl -pe 'y/\000/Q/'
290 q_to_nul () {
291         perl -pe 'y/Q/\000/'
294 q_to_cr () {
295         tr Q '\015'
298 q_to_tab () {
299         tr Q '\011'
302 append_cr () {
303         sed -e 's/$/Q/' | tr Q '\015'
306 remove_cr () {
307         tr '\015' Q | sed -e 's/Q$//'
310 # In some bourne shell implementations, the "unset" builtin returns
311 # nonzero status when a variable to be unset was not set in the first
312 # place.
314 # Use sane_unset when that should not be considered an error.
316 sane_unset () {
317         unset "$@"
318         return 0
321 test_tick () {
322         if test -z "${test_tick+set}"
323         then
324                 test_tick=1112911993
325         else
326                 test_tick=$(($test_tick + 60))
327         fi
328         GIT_COMMITTER_DATE="$test_tick -0700"
329         GIT_AUTHOR_DATE="$test_tick -0700"
330         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
333 # Stop execution and start a shell. This is useful for debugging tests and
334 # only makes sense together with "-v".
336 # Be sure to remove all invocations of this command before submitting.
338 test_pause () {
339         if test "$verbose" = t; then
340                 "$SHELL_PATH" <&6 >&3 2>&4
341         else
342                 error >&5 "test_pause requires --verbose"
343         fi
346 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
348 # This will commit a file with the given contents and the given commit
349 # message.  It will also add a tag with <message> as name.
351 # Both <file> and <contents> default to <message>.
353 test_commit () {
354         file=${2:-"$1.t"}
355         echo "${3-$1}" > "$file" &&
356         git add "$file" &&
357         test_tick &&
358         git commit -m "$1" &&
359         git tag "$1"
362 # Call test_merge with the arguments "<message> <commit>", where <commit>
363 # can be a tag pointing to the commit-to-merge.
365 test_merge () {
366         test_tick &&
367         git merge -m "$1" "$2" &&
368         git tag "$1"
371 # This function helps systems where core.filemode=false is set.
372 # Use it instead of plain 'chmod +x' to set or unset the executable bit
373 # of a file in the working directory and add it to the index.
375 test_chmod () {
376         chmod "$@" &&
377         git update-index --add "--chmod=$@"
380 # Unset a configuration variable, but don't fail if it doesn't exist.
381 test_unconfig () {
382         git config --unset-all "$@"
383         config_status=$?
384         case "$config_status" in
385         5) # ok, nothing to unset
386                 config_status=0
387                 ;;
388         esac
389         return $config_status
392 # Set git config, automatically unsetting it after the test is over.
393 test_config () {
394         test_when_finished "test_unconfig '$1'" &&
395         git config "$@"
398 test_config_global () {
399         test_when_finished "test_unconfig --global '$1'" &&
400         git config --global "$@"
403 # Use test_set_prereq to tell that a particular prerequisite is available.
404 # The prerequisite can later be checked for in two ways:
406 # - Explicitly using test_have_prereq.
408 # - Implicitly by specifying the prerequisite tag in the calls to
409 #   test_expect_{success,failure,code}.
411 # The single parameter is the prerequisite tag (a simple word, in all
412 # capital letters by convention).
414 test_set_prereq () {
415         satisfied="$satisfied$1 "
417 satisfied=" "
419 test_have_prereq () {
420         # prerequisites can be concatenated with ','
421         save_IFS=$IFS
422         IFS=,
423         set -- $*
424         IFS=$save_IFS
426         total_prereq=0
427         ok_prereq=0
428         missing_prereq=
430         for prerequisite
431         do
432                 total_prereq=$(($total_prereq + 1))
433                 case $satisfied in
434                 *" $prerequisite "*)
435                         ok_prereq=$(($ok_prereq + 1))
436                         ;;
437                 *)
438                         # Keep a list of missing prerequisites
439                         if test -z "$missing_prereq"
440                         then
441                                 missing_prereq=$prerequisite
442                         else
443                                 missing_prereq="$prerequisite,$missing_prereq"
444                         fi
445                 esac
446         done
448         test $total_prereq = $ok_prereq
451 test_declared_prereq () {
452         case ",$test_prereq," in
453         *,$1,*)
454                 return 0
455                 ;;
456         esac
457         return 1
460 # You are not expected to call test_ok_ and test_failure_ directly, use
461 # the text_expect_* functions instead.
463 test_ok_ () {
464         test_success=$(($test_success + 1))
465         say_color "" "ok $test_count - $@"
468 test_failure_ () {
469         test_failure=$(($test_failure + 1))
470         say_color error "not ok - $test_count $1"
471         shift
472         echo "$@" | sed -e 's/^/#       /'
473         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
476 test_known_broken_ok_ () {
477         test_fixed=$(($test_fixed+1))
478         say_color "" "ok $test_count - $@ # TODO known breakage"
481 test_known_broken_failure_ () {
482         test_broken=$(($test_broken+1))
483         say_color skip "not ok $test_count - $@ # TODO known breakage"
486 test_debug () {
487         test "$debug" = "" || eval "$1"
490 test_eval_ () {
491         # This is a separate function because some tests use
492         # "return" to end a test_expect_success block early.
493         eval </dev/null >&3 2>&4 "$*"
496 test_run_ () {
497         test_cleanup=:
498         expecting_failure=$2
499         test_eval_ "$1"
500         eval_ret=$?
502         if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
503         then
504                 test_eval_ "$test_cleanup"
505         fi
506         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
507                 echo ""
508         fi
509         return "$eval_ret"
512 test_skip () {
513         test_count=$(($test_count+1))
514         to_skip=
515         for skp in $GIT_SKIP_TESTS
516         do
517                 case $this_test.$test_count in
518                 $skp)
519                         to_skip=t
520                         break
521                 esac
522         done
523         if test -z "$to_skip" && test -n "$test_prereq" &&
524            ! test_have_prereq "$test_prereq"
525         then
526                 to_skip=t
527         fi
528         case "$to_skip" in
529         t)
530                 of_prereq=
531                 if test "$missing_prereq" != "$test_prereq"
532                 then
533                         of_prereq=" of $test_prereq"
534                 fi
536                 say_color skip >&3 "skipping test: $@"
537                 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
538                 : true
539                 ;;
540         *)
541                 false
542                 ;;
543         esac
546 test_expect_failure () {
547         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
548         test "$#" = 2 ||
549         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
550         export test_prereq
551         if ! test_skip "$@"
552         then
553                 say >&3 "checking known breakage: $2"
554                 if test_run_ "$2" expecting_failure
555                 then
556                         test_known_broken_ok_ "$1"
557                 else
558                         test_known_broken_failure_ "$1"
559                 fi
560         fi
561         echo >&3 ""
564 test_expect_success () {
565         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
566         test "$#" = 2 ||
567         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
568         export test_prereq
569         if ! test_skip "$@"
570         then
571                 say >&3 "expecting success: $2"
572                 if test_run_ "$2"
573                 then
574                         test_ok_ "$1"
575                 else
576                         test_failure_ "$@"
577                 fi
578         fi
579         echo >&3 ""
582 # test_external runs external test scripts that provide continuous
583 # test output about their progress, and succeeds/fails on
584 # zero/non-zero exit code.  It outputs the test output on stdout even
585 # in non-verbose mode, and announces the external script with "# run
586 # <n>: ..." before running it.  When providing relative paths, keep in
587 # mind that all scripts run in "trash directory".
588 # Usage: test_external description command arguments...
589 # Example: test_external 'Perl API' perl ../path/to/test.pl
590 test_external () {
591         test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
592         test "$#" = 3 ||
593         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
594         descr="$1"
595         shift
596         export test_prereq
597         if ! test_skip "$descr" "$@"
598         then
599                 # Announce the script to reduce confusion about the
600                 # test output that follows.
601                 say_color "" "# run $test_count: $descr ($*)"
602                 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
603                 # to be able to use them in script
604                 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
605                 # Run command; redirect its stderr to &4 as in
606                 # test_run_, but keep its stdout on our stdout even in
607                 # non-verbose mode.
608                 "$@" 2>&4
609                 if [ "$?" = 0 ]
610                 then
611                         if test $test_external_has_tap -eq 0; then
612                                 test_ok_ "$descr"
613                         else
614                                 say_color "" "# test_external test $descr was ok"
615                                 test_success=$(($test_success + 1))
616                         fi
617                 else
618                         if test $test_external_has_tap -eq 0; then
619                                 test_failure_ "$descr" "$@"
620                         else
621                                 say_color error "# test_external test $descr failed: $@"
622                                 test_failure=$(($test_failure + 1))
623                         fi
624                 fi
625         fi
628 # Like test_external, but in addition tests that the command generated
629 # no output on stderr.
630 test_external_without_stderr () {
631         # The temporary file has no (and must have no) security
632         # implications.
633         tmp=${TMPDIR:-/tmp}
634         stderr="$tmp/git-external-stderr.$$.tmp"
635         test_external "$@" 4> "$stderr"
636         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
637         descr="no stderr: $1"
638         shift
639         say >&3 "# expecting no stderr from previous command"
640         if [ ! -s "$stderr" ]; then
641                 rm "$stderr"
643                 if test $test_external_has_tap -eq 0; then
644                         test_ok_ "$descr"
645                 else
646                         say_color "" "# test_external_without_stderr test $descr was ok"
647                         test_success=$(($test_success + 1))
648                 fi
649         else
650                 if [ "$verbose" = t ]; then
651                         output=`echo; echo "# Stderr is:"; cat "$stderr"`
652                 else
653                         output=
654                 fi
655                 # rm first in case test_failure exits.
656                 rm "$stderr"
657                 if test $test_external_has_tap -eq 0; then
658                         test_failure_ "$descr" "$@" "$output"
659                 else
660                         say_color error "# test_external_without_stderr test $descr failed: $@: $output"
661                         test_failure=$(($test_failure + 1))
662                 fi
663         fi
666 # debugging-friendly alternatives to "test [-f|-d|-e]"
667 # The commands test the existence or non-existence of $1. $2 can be
668 # given to provide a more precise diagnosis.
669 test_path_is_file () {
670         if ! [ -f "$1" ]
671         then
672                 echo "File $1 doesn't exist. $*"
673                 false
674         fi
677 test_path_is_dir () {
678         if ! [ -d "$1" ]
679         then
680                 echo "Directory $1 doesn't exist. $*"
681                 false
682         fi
685 test_path_is_missing () {
686         if [ -e "$1" ]
687         then
688                 echo "Path exists:"
689                 ls -ld "$1"
690                 if [ $# -ge 1 ]; then
691                         echo "$*"
692                 fi
693                 false
694         fi
697 # test_line_count checks that a file has the number of lines it
698 # ought to. For example:
700 #       test_expect_success 'produce exactly one line of output' '
701 #               do something >output &&
702 #               test_line_count = 1 output
703 #       '
705 # is like "test $(wc -l <output) = 1" except that it passes the
706 # output through when the number of lines is wrong.
708 test_line_count () {
709         if test $# != 3
710         then
711                 error "bug in the test script: not 3 parameters to test_line_count"
712         elif ! test $(wc -l <"$3") "$1" "$2"
713         then
714                 echo "test_line_count: line count for $3 !$1 $2"
715                 cat "$3"
716                 return 1
717         fi
720 # This is not among top-level (test_expect_success | test_expect_failure)
721 # but is a prefix that can be used in the test script, like:
723 #       test_expect_success 'complain and die' '
724 #           do something &&
725 #           do something else &&
726 #           test_must_fail git checkout ../outerspace
727 #       '
729 # Writing this as "! git checkout ../outerspace" is wrong, because
730 # the failure could be due to a segv.  We want a controlled failure.
732 test_must_fail () {
733         "$@"
734         exit_code=$?
735         if test $exit_code = 0; then
736                 echo >&2 "test_must_fail: command succeeded: $*"
737                 return 1
738         elif test $exit_code -gt 129 -a $exit_code -le 192; then
739                 echo >&2 "test_must_fail: died by signal: $*"
740                 return 1
741         elif test $exit_code = 127; then
742                 echo >&2 "test_must_fail: command not found: $*"
743                 return 1
744         fi
745         return 0
748 # Similar to test_must_fail, but tolerates success, too.  This is
749 # meant to be used in contexts like:
751 #       test_expect_success 'some command works without configuration' '
752 #               test_might_fail git config --unset all.configuration &&
753 #               do something
754 #       '
756 # Writing "git config --unset all.configuration || :" would be wrong,
757 # because we want to notice if it fails due to segv.
759 test_might_fail () {
760         "$@"
761         exit_code=$?
762         if test $exit_code -gt 129 -a $exit_code -le 192; then
763                 echo >&2 "test_might_fail: died by signal: $*"
764                 return 1
765         elif test $exit_code = 127; then
766                 echo >&2 "test_might_fail: command not found: $*"
767                 return 1
768         fi
769         return 0
772 # Similar to test_must_fail and test_might_fail, but check that a
773 # given command exited with a given exit code. Meant to be used as:
775 #       test_expect_success 'Merge with d/f conflicts' '
776 #               test_expect_code 1 git merge "merge msg" B master
777 #       '
779 test_expect_code () {
780         want_code=$1
781         shift
782         "$@"
783         exit_code=$?
784         if test $exit_code = $want_code
785         then
786                 return 0
787         fi
789         echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
790         return 1
793 # test_cmp is a helper function to compare actual and expected output.
794 # You can use it like:
796 #       test_expect_success 'foo works' '
797 #               echo expected >expected &&
798 #               foo >actual &&
799 #               test_cmp expected actual
800 #       '
802 # This could be written as either "cmp" or "diff -u", but:
803 # - cmp's output is not nearly as easy to read as diff -u
804 # - not all diff versions understand "-u"
806 test_cmp() {
807         $GIT_TEST_CMP "$@"
810 # This function can be used to schedule some commands to be run
811 # unconditionally at the end of the test to restore sanity:
813 #       test_expect_success 'test core.capslock' '
814 #               git config core.capslock true &&
815 #               test_when_finished "git config --unset core.capslock" &&
816 #               hello world
817 #       '
819 # That would be roughly equivalent to
821 #       test_expect_success 'test core.capslock' '
822 #               git config core.capslock true &&
823 #               hello world
824 #               git config --unset core.capslock
825 #       '
827 # except that the greeting and config --unset must both succeed for
828 # the test to pass.
830 # Note that under --immediate mode, no clean-up is done to help diagnose
831 # what went wrong.
833 test_when_finished () {
834         test_cleanup="{ $*
835                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
838 # Most tests can use the created repository, but some may need to create more.
839 # Usage: test_create_repo <directory>
840 test_create_repo () {
841         test "$#" = 1 ||
842         error "bug in the test script: not 1 parameter to test-create-repo"
843         repo="$1"
844         mkdir -p "$repo"
845         (
846                 cd "$repo" || error "Cannot setup test environment"
847                 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
848                 error "cannot run git init -- have you built things yet?"
849                 mv .git/hooks .git/hooks-disabled
850         ) || exit
853 test_done () {
854         GIT_EXIT_OK=t
856         if test -z "$HARNESS_ACTIVE"; then
857                 test_results_dir="$TEST_DIRECTORY/test-results"
858                 mkdir -p "$test_results_dir"
859                 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
861                 cat >>"$test_results_path" <<-EOF
862                 total $test_count
863                 success $test_success
864                 fixed $test_fixed
865                 broken $test_broken
866                 failed $test_failure
868                 EOF
869         fi
871         if test "$test_fixed" != 0
872         then
873                 say_color pass "# fixed $test_fixed known breakage(s)"
874         fi
875         if test "$test_broken" != 0
876         then
877                 say_color error "# still have $test_broken known breakage(s)"
878                 msg="remaining $(($test_count-$test_broken)) test(s)"
879         else
880                 msg="$test_count test(s)"
881         fi
882         case "$test_failure" in
883         0)
884                 # Maybe print SKIP message
885                 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
887                 if test $test_external_has_tap -eq 0; then
888                         say_color pass "# passed all $msg"
889                         say "1..$test_count$skip_all"
890                 fi
892                 test -d "$remove_trash" &&
893                 cd "$(dirname "$remove_trash")" &&
894                 rm -rf "$(basename "$remove_trash")"
896                 exit 0 ;;
898         *)
899                 if test $test_external_has_tap -eq 0; then
900                         say_color error "# failed $test_failure among $msg"
901                         say "1..$test_count"
902                 fi
904                 exit 1 ;;
906         esac
909 # Test the binaries we have just built.  The tests are kept in
910 # t/ subdirectory and are run in 'trash directory' subdirectory.
911 if test -z "$TEST_DIRECTORY"
912 then
913         # We allow tests to override this, in case they want to run tests
914         # outside of t/, e.g. for running tests on the test library
915         # itself.
916         TEST_DIRECTORY=$(pwd)
917 fi
918 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
920 if test -n "$valgrind"
921 then
922         make_symlink () {
923                 test -h "$2" &&
924                 test "$1" = "$(readlink "$2")" || {
925                         # be super paranoid
926                         if mkdir "$2".lock
927                         then
928                                 rm -f "$2" &&
929                                 ln -s "$1" "$2" &&
930                                 rm -r "$2".lock
931                         else
932                                 while test -d "$2".lock
933                                 do
934                                         say "Waiting for lock on $2."
935                                         sleep 1
936                                 done
937                         fi
938                 }
939         }
941         make_valgrind_symlink () {
942                 # handle only executables, unless they are shell libraries that
943                 # need to be in the exec-path.  We will just use "#!" as a
944                 # guess for a shell-script, since we have no idea what the user
945                 # may have configured as the shell path.
946                 test -x "$1" ||
947                 test "#!" = "$(head -c 2 <"$1")" ||
948                 return;
950                 base=$(basename "$1")
951                 symlink_target=$GIT_BUILD_DIR/$base
952                 # do not override scripts
953                 if test -x "$symlink_target" &&
954                     test ! -d "$symlink_target" &&
955                     test "#!" != "$(head -c 2 < "$symlink_target")"
956                 then
957                         symlink_target=../valgrind.sh
958                 fi
959                 case "$base" in
960                 *.sh|*.perl)
961                         symlink_target=../unprocessed-script
962                 esac
963                 # create the link, or replace it if it is out of date
964                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
965         }
967         # override all git executables in TEST_DIRECTORY/..
968         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
969         mkdir -p "$GIT_VALGRIND"/bin
970         for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
971         do
972                 make_valgrind_symlink $file
973         done
974         # special-case the mergetools loadables
975         make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
976         OLDIFS=$IFS
977         IFS=:
978         for path in $PATH
979         do
980                 ls "$path"/git-* 2> /dev/null |
981                 while read file
982                 do
983                         make_valgrind_symlink "$file"
984                 done
985         done
986         IFS=$OLDIFS
987         PATH=$GIT_VALGRIND/bin:$PATH
988         GIT_EXEC_PATH=$GIT_VALGRIND/bin
989         export GIT_VALGRIND
990 elif test -n "$GIT_TEST_INSTALLED" ; then
991         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
992         error "Cannot run git from $GIT_TEST_INSTALLED."
993         PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
994         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
995 else # normal case, use ../bin-wrappers only unless $with_dashes:
996         git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
997         if ! test -x "$git_bin_dir/git" ; then
998                 if test -z "$with_dashes" ; then
999                         say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1000                 fi
1001                 with_dashes=t
1002         fi
1003         PATH="$git_bin_dir:$PATH"
1004         GIT_EXEC_PATH=$GIT_BUILD_DIR
1005         if test -n "$with_dashes" ; then
1006                 PATH="$GIT_BUILD_DIR:$PATH"
1007         fi
1008 fi
1009 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
1010 unset GIT_CONFIG
1011 GIT_CONFIG_NOSYSTEM=1
1012 GIT_ATTR_NOSYSTEM=1
1013 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
1015 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
1017 if test -z "$GIT_TEST_CMP"
1018 then
1019         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1020         then
1021                 GIT_TEST_CMP="$DIFF -c"
1022         else
1023                 GIT_TEST_CMP="$DIFF -u"
1024         fi
1025 fi
1027 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
1028 export GITPERLLIB
1029 test -d "$GIT_BUILD_DIR"/templates/blt || {
1030         error "You haven't built things yet, have you?"
1033 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
1034 then
1035         GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
1036         export GITPYTHONLIB
1037         test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
1038                 error "You haven't built git_remote_helpers yet, have you?"
1039         }
1040 fi
1042 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
1043         echo >&2 'You need to build test-chmtime:'
1044         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
1045         exit 1
1046 fi
1048 # Test repository
1049 test="trash directory.$(basename "$0" .sh)"
1050 test -n "$root" && test="$root/$test"
1051 case "$test" in
1052 /*) TRASH_DIRECTORY="$test" ;;
1053  *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
1054 esac
1055 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
1056 rm -fr "$test" || {
1057         GIT_EXIT_OK=t
1058         echo >&5 "FATAL: Cannot prepare test area"
1059         exit 1
1062 HOME="$TRASH_DIRECTORY"
1063 export HOME
1065 test_create_repo "$test"
1066 # Use -P to resolve symlinks in our working directory so that the cwd
1067 # in subprocesses like git equals our $PWD (for pathname comparisons).
1068 cd -P "$test" || exit 1
1070 this_test=${0##*/}
1071 this_test=${this_test%%-*}
1072 for skp in $GIT_SKIP_TESTS
1073 do
1074         case "$this_test" in
1075         $skp)
1076                 say_color skip >&3 "skipping test $this_test altogether"
1077                 skip_all="skip all tests in $this_test"
1078                 test_done
1079         esac
1080 done
1082 # Provide an implementation of the 'yes' utility
1083 yes () {
1084         if test $# = 0
1085         then
1086                 y=y
1087         else
1088                 y="$*"
1089         fi
1091         while echo "$y"
1092         do
1093                 :
1094         done
1097 # Fix some commands on Windows
1098 case $(uname -s) in
1099 *MINGW*)
1100         # Windows has its own (incompatible) sort and find
1101         sort () {
1102                 /usr/bin/sort "$@"
1103         }
1104         find () {
1105                 /usr/bin/find "$@"
1106         }
1107         sum () {
1108                 md5sum "$@"
1109         }
1110         # git sees Windows-style pwd
1111         pwd () {
1112                 builtin pwd -W
1113         }
1114         # no POSIX permissions
1115         # backslashes in pathspec are converted to '/'
1116         # exec does not inherit the PID
1117         test_set_prereq MINGW
1118         test_set_prereq SED_STRIPS_CR
1119         ;;
1120 *CYGWIN*)
1121         test_set_prereq POSIXPERM
1122         test_set_prereq EXECKEEPSPID
1123         test_set_prereq NOT_MINGW
1124         test_set_prereq SED_STRIPS_CR
1125         ;;
1126 *)
1127         test_set_prereq POSIXPERM
1128         test_set_prereq BSLASHPSPEC
1129         test_set_prereq EXECKEEPSPID
1130         test_set_prereq NOT_MINGW
1131         ;;
1132 esac
1134 test -z "$NO_PERL" && test_set_prereq PERL
1135 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1136 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
1137 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1139 # Can we rely on git's output in the C locale?
1140 if test -n "$GETTEXT_POISON"
1141 then
1142         GIT_GETTEXT_POISON=YesPlease
1143         export GIT_GETTEXT_POISON
1144         test_set_prereq GETTEXT_POISON
1145 else
1146         test_set_prereq C_LOCALE_OUTPUT
1147 fi
1149 # Use this instead of test_cmp to compare files that contain expected and
1150 # actual output from git commands that can be translated.  When running
1151 # under GETTEXT_POISON this pretends that the command produced expected
1152 # results.
1153 test_i18ncmp () {
1154         test -n "$GETTEXT_POISON" || test_cmp "$@"
1157 # Use this instead of "grep expected-string actual" to see if the
1158 # output from a git command that can be translated either contains an
1159 # expected string, or does not contain an unwanted one.  When running
1160 # under GETTEXT_POISON this pretends that the command produced expected
1161 # results.
1162 test_i18ngrep () {
1163         if test -n "$GETTEXT_POISON"
1164         then
1165             : # pretend success
1166         elif test "x!" = "x$1"
1167         then
1168                 shift
1169                 ! grep "$@"
1170         else
1171                 grep "$@"
1172         fi
1175 # test whether the filesystem supports symbolic links
1176 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1177 rm -f y
1179 # When the tests are run as root, permission tests will report that
1180 # things are writable when they shouldn't be.
1181 test -w / || test_set_prereq SANITY